/*
  Software PWM using Timer0 Interrupt
  Program by Ananth
  Compiler - MicroC Pro
  Simulation - ISIS
  MCU -PIC12f617
  */
  /*
    Description: This is a software pwm to control the brightness of a LED connected at Port 4 of MCU PIC12f675.
    Internal Oscillator 4MHZ
  */
 char cnt,time=0, pwm_val=0; i;
 
//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  1820 and 18S20: 9  (default setting; can be 9,10,11,or 12)
//  18B20: 12
const unsigned short TEMP_RESOLUTION = 9;


 
 unsigned temp, bliknout;
 




 
 void Display_Temperature(unsigned int temp2write) {
  const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
  char temp_whole;
  unsigned int temp_fraction;
  


  // Check if temperature is negative
  if (temp2write & 0x8000) {
     //text[0] = '-';
     temp2write = ~temp2write + 1;
     }

  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  
  bliknout=temp_whole;


  if(temp_whole>15){CCPR1L=0;}
  if(temp_whole>20){CCPR1L=0;}
  if(temp_whole>25){CCPR1L=5;}
  if(temp_whole>30){CCPR1L=10;}
  if(temp_whole>40){CCPR1L=15;}
  if(temp_whole>50){CCPR1L=25;}
  if(temp_whole>60){CCPR1L=50;}
  if(temp_whole>70){CCPR1L=100;}
  if(temp_whole<20){CCPR1L=0; }

}
 
 void interrupt(void) {




   }


unsigned short current_duty, old_duty, current_duty1, old_duty1;


void main () {
     TRISIO.F5 = 1;
     TRISIO.F4 = 0;
     TRISIO.F2 = 0;
     TRISIO.F3 = 0;  //GP3 jako vystup (MCLR) je pouze vstupni pin, ale aby slo programovat bez odpojeni napajeni
     //CMCON=0x07;
     C1ON_bit = 0;                       // Disable comparators

     ANSEL  = 0;                         // Configure AN pins as digital
     //ANSELH = 0;
     C1ON_bit = 0;                       // Disable comparators
     //C2ON_bit = 0;

     ANSEL=0x00;
     GPIO = 0x00;
     OPTION_REG.T0CS=0;     //internal clock for timer0
     OPTION_REG.PSA=0;       //prescaller is assigned to WDT
     OPTION_REG.F2=0;     //prescaller 1:2
     OPTION_REG.F1=0;
     OPTION_REG.F0=0;
     //INTCON.GIE=1;        //enable global interrupt
     INTCON.T0IE=1;       //enable timer0 interrupt
     

     
     // Timer 2  pro PWM
     PR2=0x65;   // 8 MHz clock -> 19.61kHz PWM frequency   + prescaler 1
     T2CON = (1<<TMR2ON);


     // Initialize Control PWM
     CCPR1L  = 0;          // Initial Duty
     CCP1CON = 0b10001111;
     APFCON=0b00010011;    //PWM P1B out na GP4
     
     //test led vent a led start
     APFCON=0b00010010;
     delay_ms(500);     //test ventilatoru
     delay_ms(500);
     GPIO.F2=1; //LED
     CCPR1L=100; //vent na 100
     delay_ms(500);
     delay_ms(500);
     GPIO.F2=0;
     CCPR1L=0; //vent na 0
     delay_ms(700);
     APFCON=0b00010011;
     //test led a vent stop
     
     
     
     
     
     while(1){
     

      
      delay_ms(500);

      

      //--- Perform temperature reading
      APFCON=0b00010010; //PWM P1B out na GP4
      TRISIO.F5 = 1;
      Ow_Reset(&GPIO, 5);                         // Onewire reset signal
      Ow_Write(&GPIO, 5, 0xCC);                   // Issue command SKIP_ROM
      Ow_Write(&GPIO, 5, 0x44);                   // Issue command CONVERT_T
      Delay_us(120);

      Ow_Reset(&GPIO, 5);
      Ow_Write(&GPIO, 5, 0xCC);                   // Issue command SKIP_ROM
      Ow_Write(&GPIO, 5, 0xBE);                   // Issue command READ_SCRATCHPAD

      temp =  Ow_Read(&GPIO, 5);
      temp = (Ow_Read(&GPIO, 5) << 8) + temp;
      //INTCON.GIE=1;
      APFCON=0b00010011; //PWM P1B out na GP4
      
      Display_Temperature(temp);
      
     /* while(bliknout>1){

      GPIO.F2=1;
      delay_ms(100);
      GPIO.F2=0;
      delay_ms(200);
      bliknout--;
      }
     */
     
      GPIO.F2=1;
      delay_ms(1);
      GPIO.F2=0;
      delay_ms(1800);
     
     }
     

  }